#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <fakemeta>
#include <hamsandwich>
#include <engine>
#include <fun>
#include <xs>
#include <re_cmps>

new g_restart_attempt[33]=0
new bot[33]
new HitTimes[33]
new g_sprite
new laser
new Float:Vector[33][3]
new Origin[33][3]

#if AMXX_VERSION_NUM < 183
	#define client_disconnected client_disconnect
#endif
new g_switch=0
public plugin_init()
{
	register_plugin("AI Puncture", "1.4", "YeZiJiu");
	RegisterHam(Ham_Killed, "player", "func_Ham_Killed_Player");
	RegisterHam(Ham_TakeDamage, "player", "func_Ham_TakeDamage");
	register_event("ResetHUD", "event_hud_reset", "be");
	register_message( get_user_msgid( "TextMsg" ), "Message_TextMsg" );
	register_clcmd("say /cd", "Amx_ShowMenu");
	register_clcmd("say_team /cd", "Amx_ShowMenu");
	register_clcmd("ShowOptionMenu", "Amx_ShowMenu");
	mp_reg_menuitem("AI穿点训练",98)
}
public match_create_pre()
{
	for(new pid=1;pid<32;pid++)
	{
		if(is_user_connected(pid) && g_switch==1)
			client_color_text(pid,pid,"比赛即将开始训练插件已关闭!")
		if (bot[pid])
		{
			UpdateTargetData(pid, 0);
			RemoveBot(pid);
			clear_data(pid)
		}
	}
	g_switch=0
}
public match_externalmenu(id,item)
{
	if(item==98)
	{
		if(get_match_type()!=MATCH_NOSTART)
		{
			client_color_text(id,id,"比赛已开启!此功能无法开启!")
			return
		}
		if(g_switch==0)
		{
			g_switch=1
			client_color_text(0,id,"插件已开启!所有玩家均可通过^4say /cd^1打开训练菜单")
		}
		else
		{
			for(new pid=1;pid<32;pid++)
			{
				if (bot[pid])
				{
					UpdateTargetData(pid, 0);
					RemoveBot(pid);
					clear_data(pid)
				}
			}
			g_switch=0
			client_color_text(0,id,"插件已关闭!已清除所有玩家的AI")
		}
	}
}
public Message_TextMsg() 
{
	static szMessages[32];
	get_msg_arg_string(2,szMessages,charsmax(szMessages));
	if(equal(szMessages,"#Game_will_restart_in") || equal(szMessages,"#Game_Commencing"))
	{
		for(new id=1;id<32;id++)
		{
			g_restart_attempt[id] = 1;
		}
	}
}
public client_connect(id)
{
	clear_data(id)
}
public plugin_end()
{
	for(new id=1;id<32;id++)
	{
		if (bot[id])
		{
			UpdateTargetData(id, 0);
			RemoveBot(id);
			clear_data(id)
		}
	}
}
public plugin_precache()
{
	g_sprite = precache_model("sprites/dot.spr");
	laser = precache_model("sprites/laserbeam.spr");
}
public SetTarget(id)
{
	entity_get_vector(id,EV_VEC_origin, Vector[id]);
	get_user_origin(id, Origin[id], 0);
	client_color_text(id, id, "请在^3 3秒^1 内离开当前位置!以防止AI生成失败！");
	set_task(3.0, "BulidFakePlayer", id);
}

public make_TE_BEAMENTPOINT(id, Float:target_origin[3])
{
	message_begin(MSG_ONE_UNRELIABLE, SVC_TEMPENTITY , {0,0,0}, id);
	write_byte(TE_BEAMENTPOINT);
	write_short(id);
	write_coord(floatround(target_origin[0]));
	write_coord(floatround(target_origin[1]));
	write_coord(floatround(target_origin[2]));
	write_short(laser);
	write_byte(1);
	write_byte(1);
	write_byte(150);
	write_byte(32);
	write_byte( 0 );
	write_byte( 0 ) // R
	write_byte( 255 ) // G
	write_byte( 0 ) // B
	write_byte( 150 );
	write_byte( 25 );
	message_end();
}

public BulidFakePlayer(id)
{
	if(g_switch==0)
	{
		client_color_text(id,id,"管理员已关闭此功能")
		return
	}
	AddBot(id);
	UpdateTargetData(id, 0);
	HitTimes[id] = 0;
}

public ShowCoordinate(id, Float:vec_Target[])
{
	new size = 30;
	message_begin(MSG_ONE, SVC_TEMPENTITY, {0,0,0}, id);
	write_byte(TE_BEAMPOINTS);
	write_coord(size + floatround(vec_Target[0]));
	write_coord(floatround(vec_Target[1]));
	write_coord(floatround(vec_Target[2]));
	write_coord(floatround(vec_Target[0]) - size);
	write_coord(floatround(vec_Target[1]));
	write_coord(floatround(vec_Target[2]));
	write_short(g_sprite);
	write_byte(1);
	write_byte(1);
	write_byte(200);
	write_byte(10);            
	write_byte( 0 )
	write_byte( 255 ) // R
	write_byte( 50 ) // G
	write_byte( 50 ) // B
	write_byte( 150 )                
	write_byte( 25 )
	message_end();


	message_begin(MSG_ONE, SVC_TEMPENTITY, {0,0,0}, id);
	write_byte(TE_BEAMPOINTS);
	write_coord(floatround(vec_Target[0]));
	write_coord(size + floatround(vec_Target[1]));
	write_coord(floatround(vec_Target[2]));
	write_coord(floatround(vec_Target[0]));
	write_coord(floatround(vec_Target[1]) - size);
	write_coord(floatround(vec_Target[2]));
	write_short(g_sprite);
	write_byte(1);
	write_byte(1);
	write_byte(200);
	write_byte(10)            
	write_byte( 0 )
	write_byte( 255 ) // R
	write_byte( 55 ) // G
	write_byte( 50 ) // B
	write_byte( 150 )                
	write_byte( 25 )
	message_end();

	message_begin(MSG_ONE, SVC_TEMPENTITY, {0,0,0}, id);
	write_byte(TE_BEAMPOINTS);
	write_coord(floatround(vec_Target[0]));
	write_coord(floatround(vec_Target[1]));
	write_coord(size + floatround(vec_Target[2]));
	write_coord(floatround(vec_Target[0]));
	write_coord(floatround(vec_Target[1]));
	write_coord(floatround(vec_Target[2]) - size);
	write_short(g_sprite);
	write_byte(1);
	write_byte(1);
	write_byte(200);
	write_byte(10);          
	write_byte( 0 )
	write_byte( 255 ) // R
	write_byte( 55 ) // G
	write_byte( 50 ) // B
	write_byte( 150 )                
	write_byte( 25 )
	message_end();
	return 1;
}
public client_disconnected(id)
{
	if (bot[id])
	{
		UpdateTargetData(id, 0);
		RemoveBot(id);
		clear_data(id)
	}
}
public clear_data(id)
{
	bot[id] = 0;
	HitTimes[id] = 0;
	g_restart_attempt[id]=0
	Vector[id][0]=0.0
	Vector[id][1]=0.0
	Vector[id][2]=0.0
	Origin[id][0]=0
	Origin[id][1]=0
	Origin[id][2]=0
}
public func_Ham_TakeDamage(Victim, Inflictor, Attacker, Float:fDamage, BitDamage)
{
	if (bot[Attacker] == Victim)
	{
		set_user_health(bot[Attacker], 999);
		HitTimes[Attacker] = HitTimes[Attacker] + 1;
		UpdateTargetData(Attacker, floatround(fDamage));
	}
}

public func_Ham_Killed_Player(Victim, Killer, Shouldgib)
{
	if (bot[Killer] == Victim)
		UpdateTargetData(Killer, 0);
}

public AddBot(id)
{
	new szOrigin[3]
	get_user_origin(id, szOrigin, 0);
	if(szOrigin[0]==Origin[id][0] && szOrigin[1]==Origin[id][1])
	{
		server_print("玩家当前位置 %d %d %d",szOrigin[0],szOrigin[1],szOrigin[2])
		server_print("玩家先前位置 %d %d %d",Origin[id][0],Origin[id][1],Origin[id][2])
		client_color_text(id, id, "AI机器人^3创建失败^1!^4AI位置有玩家实体存在");
		return PLUGIN_HANDLED
	}
	new szName[33];
	format(szName, 32, "TrainingZone>>AI:%d",get_user_userid(id));
	bot[id] = engfunc(EngFunc_CreateFakeClient, szName);
	if (!bot[id])
	{
		return PLUGIN_HANDLED
	}
	engfunc(EngFunc_FreeEntPrivateData, bot[id]);
	static szRejectReason[128];
	dllfunc(DLLFunc_ClientConnect, bot[id], szName, "121.14.77.201", szRejectReason);
	if (!is_user_connected(bot[id]))
	{
		return PLUGIN_HANDLED
	}
	dllfunc(DLLFunc_ClientPutInServer, bot[id]);
	set_pev(bot[id], 83, pev(bot[id], 83) | 8192);
	set_pev(bot[id], 84, pev(bot[id], 84) | 8192);
	if (fm_cs_get_user_team(id) == 1)
	{
		engclient_cmd(bot[id], "jointeam","2");
		fm_cs_set_user_team(bot[id],2)
	}
	else	
	{
		engclient_cmd(bot[id], "jointeam","1");
		fm_cs_set_user_team(bot[id],1)
	}
	fm_user_spawn(bot[id]);
	fm_cs_reset_user_model_index(bot[id])
	set_user_origin(bot[id], Origin[id]);
	set_user_health(bot[id], 999);
	client_color_text(id, id, "AI机器人^3创建成功^1您可通过^4显示AI坐标^1查看机器人位置(提示:CS自身原因需对AI造成伤害后才可正常查看AI模型)");
	UpdateTargetData(id, 0);
	
	message_begin(MSG_ALL, get_user_msgid("TeamInfo"));
	write_byte(bot[id]);
	write_string("SPECTATOR");
	message_end();
	fm_cs_set_user_team(bot[id],3)
	return PLUGIN_HANDLED
}
stock fm_cs_reset_user_model_index(id)
{
	if (pev_valid(id) != 2)
		return;
	
	switch (fm_cs_get_user_team(id))
	{
		case CS_TEAM_T:
		{
			set_pdata_int(id, 491, engfunc(EngFunc_ModelIndex, "models/player/terror/terror.mdl"))
		}
		case CS_TEAM_CT:
		{
			set_pdata_int(id, 491, engfunc(EngFunc_ModelIndex, "models/player/urban/urban.mdl"))
		}
	}
}
stock fm_cs_set_user_team(id, team)
{
	#if cellbits == 32
	return set_pdata_int(id, 114, team, 5)
	#else
	return set_pdata_int(id, 139, team, 5)
	#endif
}
stock fm_cs_get_user_team(id)
{
	#if cellbits == 32
	return get_pdata_int(id, 114, 5);
	#else
	return get_pdata_int(id, 139, 5);
	#endif
}

public fm_user_spawn(id)
{
	set_pev(id, pev_deadflag, 3);
	dllfunc(DLLFunc_Spawn, id);
	set_pev(id, pev_iuser1, 0);
}

public RemoveBot(id)
{
	if (bot[id])
	{
		server_cmd("kick #%d", get_user_userid(bot[id]));
		bot[id] = 0;
	}
}

public UpdateTargetData(id, damage)
{
	if (is_user_alive(bot[id]))
	{
		set_hudmessage(27, 247, 27, 0.85, 0.35, 0, 1.0, 4.0, 0.1, 2.0, 1);
		show_hudmessage(id, "命中目标次数：%d^n上次攻击伤害：%d", HitTimes[id], damage);
		set_user_health(bot[id], 999);
	}
}
public event_hud_reset(id)
{
	if(g_switch!=1) return
	if (g_restart_attempt[id])
	{
		g_restart_attempt[id] = 0;
	}
	event_player_spawn(id);
}

public event_player_spawn(id)
{
	if(g_switch!=1) return
	if (cs_get_user_plant(id))
	{
		engclient_cmd(id, "drop", "weapon_c4");
		set_task(3.0, "strip_c4", id);
	}
	if (is_user_bot(bot[id]))
	{
		HitTimes[id] = 0;
		UpdateTargetData(id, 0);
		RemoveBot(id);
		clear_data(id)
		client_color_text(id, id, "已移除AI机器人,您可以通过菜单重新创建");
	}
}

public Amx_ShowMenu(id)
{
	if(g_switch==0)
	{
		client_color_text(id,id,"管理员已关闭此功能")
		return PLUGIN_HANDLED
	}
	if (is_user_alive(id) && (cs_get_user_team(id) == CS_TEAM_CT || cs_get_user_team(id) == CS_TEAM_T))
	{
		new menu = menu_create("\r穿点训练插件菜单\dBy:叶子玖", "ShowOptionMenu_Handler");
		menu_additem(menu, "\y生成训练AI");	//1
		menu_additem(menu, "\y清除训练AI");//2
		menu_additem(menu, "\y辅助瞄准AI");//3
		menu_additem(menu, "\y显示AI坐标^n");//4
		menu_additem(menu, "\y补满自身状态^n");//4
		menu_additem(menu, "获取武器(\y沙漠之鹰\w)");//6
		menu_additem(menu, "获取武器(\y突击步枪\w)");//7
		menu_additem(menu, "获取武器(\y狙击步枪\w)");//8
		menu_additem(menu, "获取武器(\y机枪\w)^n");//9
		menu_setprop(menu, 1, 0);
		menu_additem(menu, "关闭菜单", "MENU_EXIT", 0, -1);
		menu_display(id, menu, 0);
	}
	else
		client_color_text(id, id, "您当前非有效存活状态!");
	return PLUGIN_HANDLED
}
public ShowOptionMenu_Handler(id, menu, item)
{
	switch(item)
	{
		case 0:{
			if (bot[id])
			{
				client_color_text(id, id, "AI机器人^3已创建^1如需更换位置请先^4清除训练AI");
				Amx_ShowMenu(id)
				return PLUGIN_HANDLED
			}
			Amx_ShowMenu(id)
			SetTarget(id);
		}
		case 1:{
			if (bot[id])
			{
				HitTimes[id] = 0;
				UpdateTargetData(id, 0);
				RemoveBot(id);
				clear_data(id)
				client_color_text(id, id, "已移除AI机器人,您可以通过菜单重新创建");
			}else
				client_color_text(id, id, "尚未创建^3AI机器人^1,请在控制台输入^4ShowOptionMenu^1打开菜单创建!建议^3绑定快捷键^1快速打开菜单");
			Amx_ShowMenu(id)
			return PLUGIN_HANDLED
		}
		case 2:
		{
			if (bot[id])
			{
				make_TE_BEAMENTPOINT(id, Vector[id]);
			}else
				client_color_text(id, id, "尚未创建^3AI机器人^1,请在控制台输入^4ShowOptionMenu^1打开菜单创建!建议^3绑定快捷键^1快速打开菜单");
			Amx_ShowMenu(id)
			return PLUGIN_HANDLED
		}
		case 3:
		{
			if (bot[id])
			{
				ShowCoordinate(id, Vector[id]);
			}else
				client_color_text(id,id, "尚未创建^3AI机器人^1,请在控制台输入^4ShowOptionMenu^1打开菜单创建!建议^3绑定快捷键^1快速打开菜单");
			Amx_ShowMenu(id)
			return PLUGIN_HANDLED
		}
		case 4:
		{
			cs_set_user_armor(id,100,CS_ARMOR_VESTHELM);
			set_user_health(id,100);
			client_color_text(id,id, "您的血量重置为^3 100HP^1护甲已^4补满");
			Amx_ShowMenu(id)
			return PLUGIN_HANDLED
		}
		case 5:
		{
			strip_user_weapons(id)
			give_item(id, "weapon_deagle");
			cs_set_user_bpammo(id, CSW_DEAGLE, 70);
			give_item(id, "weapon_knife");
			Amx_ShowMenu(id)
			return PLUGIN_HANDLED
		}
		case 6:
		{
			strip_user_weapons(id)
			give_item(id, "weapon_aug");
			cs_set_user_bpammo(id, CSW_AUG, 240);
			give_item(id, "weapon_m4a1");
			cs_set_user_bpammo(id, CSW_M4A1, 240);
			give_item(id, "weapon_sg552");
			cs_set_user_bpammo(id, CSW_SG552, 240);
			give_item(id, "weapon_ak47");
			cs_set_user_bpammo(id, CSW_AK47, 240);
			give_item(id, "weapon_galil");
			cs_set_user_bpammo(id, CSW_GALIL, 240);
			give_item(id, "weapon_famas");
			cs_set_user_bpammo(id, CSW_FAMAS, 240);
			give_item(id, "weapon_knife");
			Amx_ShowMenu(id)
			return PLUGIN_HANDLED
		}
		case 7:
		{
			strip_user_weapons(id)
			give_item(id, "weapon_scout");
			cs_set_user_bpammo(id, CSW_SCOUT, 120);
			give_item(id, "weapon_awp");
			cs_set_user_bpammo(id, CSW_AWP, 120);
			give_item(id, "weapon_knife");
			Amx_ShowMenu(id)
			return PLUGIN_HANDLED
		}
		case 8:
		{
			strip_user_weapons(id)
			give_item(id, "weapon_m249");
			give_item(id, "weapon_knife");
			cs_set_user_bpammo(id, 20, 400);
			Amx_ShowMenu(id)
			return PLUGIN_HANDLED
		}
		default:menu_destroy(menu);
	}
	return PLUGIN_HANDLED
}

public strip_c4(id)
{
	new weaponbox;
	new bomb = find_ent_by_class(-1, "weapon_c4");
	if (bomb && (weaponbox = entity_get_edict(bomb, 4)) > get_maxplayers())
	{
		remove_entity(weaponbox);
		remove_entity(bomb);
		message_begin(MSG_ALL, get_user_msgid("BombPickup"))
		message_end();
	}
}
stock client_color_text(const id,const color, const input[], any:...)
{
	new msg[1476]
	msg[0] = 0x04
	new len=formatex(msg,charsmax(msg)-1,"^4【AI穿点训练】^1")
	vformat(msg[len], charsmax(msg)-len-1, input, 3)
	static msgSayText
	if( !msgSayText )
		msgSayText = get_user_msgid("SayText")
	message_begin(id ? MSG_ONE : MSG_ALL, msgSayText, .player=id) 
	write_byte(color ? color : 1)
	write_string(msg)
	message_end()
}